PROGRAM Counting_Out;

#include "str.h"

CONST probname = 'NZ93_';
      prob_id = 'S';
      file_id = 'PROBLEM';
      full_hand = 52;  {52;}

TYPE  link = ^card;
      card = record
               suit, face: char;
               next, back: link end;

VAR   debugcounter: integer;
      deck: record count: integer; top, bot: link end;
      k: integer;
      line: string;
      l: integer;
      thiscard: card;
      done: Boolean;

FUNCTION  ReadDeck: Boolean;     forward;
PROCEDURE SolveProblem;          forward;

PROCEDURE Error(s:string);
begin
  writeln; writeln(s); readln; HALT;
end;

PROCEDURE MainProg;
begin  {Main}

while ReadDeck do
  SolveProblem;

end; {of main procedure}

PROCEDURE readline;
begin readln(line);
line := line + '@'; l := 1 end;

PROCEDURE ReadCard(var p: link);
begin
new(p);
with p^ do begin
  if line[l] = '@' then readline;
  while line[l] = ' ' do Inc(l);
  suit := line[l]; Inc(l);
  face := line[l]; Inc(l);
  end;
end;

PROCEDURE InitDeck;
begin
with deck do begin
  ReadCard(top); top^.next := nil; top^.back := nil;
  bot := top end;
end;

PROCEDURE AddToDeck;
var p: link;
begin
with deck do begin
  ReadCard(p);
  p^.next := top; top^.back := p;
  top := p end;
end;

function ReadDeck: Boolean;
var i: integer;

begin
readln(k);
if k = 0
  then ReadDeck := false
  else begin
    ReadDeck := true;
    readline; InitDeck;
    for i := 2 to full_hand do AddToDeck;
    with deck do begin
      top^.back := bot; bot^.next := top;
      count := full_hand end;
    end;
end;

PROCEDURE DumpCard(c: card);
begin
with c do begin
  writeln(suit, face) end;
end;

PROCEDURE SolveProblem;
var i: integer;
    p: link;

begin
with deck do begin
  p := deck.top;
  while count > 0 do begin
    for i := 1 to k do p := p^.next;
    p^.back^.next := p^.next;
    p^.next^.back := p^.back;
    Dec(count); p := p^.next;
    end;
  end; {with deck}
DumpCard(p^);
end;

begin mainprog end.

