PROGRAM Versary;

#include "str.h"

CONST probname = 'NZ93_';
      prob_id = 'Y';
      file_id = 'PROBLEM';
      blank_line = '                                                 ';
      seconds_per_minute = 60;
      seconds_per_hour = 3600;
      seconds_per_day = 24 * 3600;
      seconds_per_year = 365 * 24 * 3600;

VAR   debugcounter: integer;
      monthtab:array[0..1, 1..13] of integer;
      year, month, day,
      hour, minute, second: integer;
      month_ok, day_ok, hour_ok, minute_ok, second_ok: Boolean;
      anniversary, longdays, longseconds: longint;
      anniversary_type: char;

FUNCTION  ReadData: Boolean;     forward;
PROCEDURE SolveProblem;          forward;

PROCEDURE Error(s:string);
begin
  writeln; writeln(s); HALT;
end;

PROCEDURE MainProg;
begin  {Main}

monthtab[0, 1] := 0;
monthtab[0, 2] := 31;
monthtab[0, 3] := 28;
monthtab[0, 4] := 31;
monthtab[0, 5] := 30;
monthtab[0, 6] := 31;
monthtab[0, 7] := 30;
monthtab[0, 8] := 31;
monthtab[0, 9] := 31;
monthtab[0, 10] := 30;
monthtab[0, 11] := 31;
monthtab[0, 12] := 30;
monthtab[0, 13] := 31;
monthtab[1, 1] := 0;
monthtab[1, 2] := 31;
monthtab[1, 3] := 28;
monthtab[1, 4] := 31;
monthtab[1, 5] := 30;
monthtab[1, 6] := 31;
monthtab[1, 7] := 30;
monthtab[1, 8] := 31;
monthtab[1, 9] := 31;
monthtab[1, 10] := 30;
monthtab[1, 11] := 31;
monthtab[1, 12] := 30;
monthtab[1, 13] := 31;

for month := 2 to 13 do begin
  monthtab[0, month] := monthtab[0, month-1] + monthtab[0, month];
  monthtab[1, month] := monthtab[1, month-1] + monthtab[1, month] end;

while ReadData do
  SolveProblem;

end; {of main procedure}

function ReadData: Boolean;
var line: string;
    p: integer;

function ExtractNum: longint;
var x: longint;
begin
x := 0;
while line[p] in ['0'..'9'] do
  begin x := x * 10 + ord(line[p]) - ord('0'); Inc(p) end;
ExtractNum := x;
end;

PROCEDURE Grab(var unit_s:integer; var unit_ok: Boolean);
begin
{**writeln('Entering Grab - p = ', p, ' line[p] = ', line[p]);{**}
if line[p] = ':'
  then begin Inc(p); unit_s := ExtractNum; unit_ok := true end
  else begin unit_ok := false; unit_s := 0 end;
end;  {Grab}

begin  {Read Data}
line := blank_line; readln(line);
if line[1] = '0'
  then ReadData := false
  else begin
    p := 1; ReadData := true;
    year := ExtractNum;
    Grab(month, month_ok);
    Grab(day, day_ok);
    Grab(hour, hour_ok);
    Grab(minute, minute_ok);
    Grab(second, second_ok);
    while line[p] = ' ' do Inc(p);
    anniversary := ExtractNum;
    while line[p] = ' ' do Inc(p);
    anniversary_type := line[p];
    end;
end;

FUNCTION LY(y: integer): integer;
begin
LY := ord((y mod 4 = 0) AND NOT(y mod 100 = 0) OR (y mod 400 = 0));
end;

PROCEDURE ConvertToNumbers;
var y: integer;

begin
longdays := 0;
for y := 1900 to year-1 do longdays := longdays + monthtab[LY(y), 13];
longdays := longdays + monthtab[LY(year), month] + day;
longseconds := seconds_per_hour*hour + seconds_per_minute*minute + second;
end;

FUNCTION Share(v: integer): integer;
{Naughty function -- side effects!}
begin Share := longseconds mod v; longseconds := longseconds div v end;

PROCEDURE ConvertToUnits;
begin
if longseconds > 0
  then begin
    second := Share(60);
    minute := Share(60);
    hour   := Share(24) end;
year := 1900; longdays := longdays + longseconds;
while longdays > monthtab[LY(year), 13] do
  begin longdays := longdays - monthtab[LY(year), 13]; Inc(year) end;
month := 1; while monthtab[LY(year), month] <= longdays do Inc(month);
Dec(month); day := longdays - monthtab[LY(year), month];
end;

PROCEDURE PrintDate;
begin
write(year:1);
if month_ok  then write(':', month:1);
if day_ok    then write(':', day:1);
if hour_ok   then write(':', hour:1);
if minute_ok then write(':', minute:1);
if second_ok then write(':', second:1);
end;

PROCEDURE SolveProblem;
begin
PrintDate; write(' + ', anniversary:1, anniversary_type, ' -> ');

if anniversary_type = 'y'
  then year := year + anniversary
  else begin
    ConvertToNumbers;
    case anniversary_type of
      'w': longdays := longdays + 52*anniversary;
      'd': longdays := longdays + anniversary;
      'h': longseconds := longseconds + seconds_per_hour*anniversary;
      'm': longseconds := longseconds + seconds_per_minute*anniversary;
      's': longseconds := longseconds + anniversary;
      otherwise Error('Invalid character as versary type '+ anniversary_type)
      end;  {case}
    ConvertToUnits end;
PrintDate; writeln
end;

begin mainprog end.

